//=====================================================================
//	      .
//=====================================================================

//---------------------------------------------------------------------
#property copyright 	"Dima S., 2010 ."
#property link      	"dimascub@mail.com"
//---------------------------------------------------------------------

//---------------------------------------------------------------------
#import		"user32.dll"
int		GetSystemMetrics( int _index );
#import
//---------------------------------------------------------------------
#define		SM_CXSCREEN				0
#define		SM_CYSCREEN				1
#define		SM_CXFULLSCREEN		16
#define		SM_CYFULLSCREEN		17
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//	 :
//---------------------------------------------------------------------
#include	<ChartObjects\ChartObjectsTxtControls.mqh>
#include	<Arrays\List.mqh>
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
class TTitleDisplay : public CChartObjectLabel
{
protected:
	long		chart_id;
	int			sub_window;
	long		chart_width;																								//    
	long		chart_height;																								//    
	long		chart_width_step;																						//     
	long		chart_height_step;																					//     
	int			columns_number;																							//  
	int			lines_number;																								//  
	int			curr_column;
	int			curr_row;

private:
	void		SetParams( long _chart_id, int _window, int _cols, int _lines );//   

public:
	string	GetUniqName( );																							//   
	bool		Create( long _chart_id, int _window, int _cols, int _lines, int _col, int _row );
	void		RecalcAndRedraw( );																					//    

	
public:
	void		TTitleDisplay( );																						// 
	void		~TTitleDisplay( );																					// 

};
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
void
TTitleDisplay::TTitleDisplay( )
{
}

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
void
TTitleDisplay::~TTitleDisplay( )
{
}

//---------------------------------------------------------------------
//	C :
//---------------------------------------------------------------------
bool
TTitleDisplay::Create( long _chart_id, int _window, int _cols, int _lines, int _col, int _row )
{
	this.curr_column = _col;
	this.curr_row = _row;
	SetParams( _chart_id, _window, _cols, _lines );

	return( this.Create( this.chart_id, this.GetUniqName( ), this.sub_window, ( int )( _col * this.chart_width_step ), ( int )( _row * this.chart_height_step )));
}

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
void
TTitleDisplay::SetParams( long _chart_id, int _window, int _cols, int _lines )
{
	this.chart_id = _chart_id;
	this.sub_window = _window;
	this.columns_number = _cols;
	this.lines_number = _lines;

//	    :
	this.chart_width = GetSystemMetrics( SM_CXFULLSCREEN );
	this.chart_height = GetSystemMetrics( SM_CYFULLSCREEN );

//	   :
	this.chart_width_step = this.chart_width / _cols;
	this.chart_height_step = this.chart_height / _lines;
}

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
void
TTitleDisplay::RecalcAndRedraw( )
{
//	    :
	long	width = GetSystemMetrics( SM_CXFULLSCREEN );
	long	height = GetSystemMetrics( SM_CYFULLSCREEN );
	if( width == this.chart_width && height == this.chart_height )
	{
		return;
	}

	this.chart_width = width;
	this.chart_height = height;

//	   :
	this.chart_width_step = this.chart_width / this.columns_number;
	this.chart_height_step = this.chart_height / this.lines_number;

//	    :
	this.X_Distance(( int )( this.curr_column * this.chart_width_step ));
	this.Y_Distance(( int )( this.curr_row * this.chart_height_step ));
}

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
string
TTitleDisplay::GetUniqName( )
{
	static uint	prev_count = 0;

	uint			count = GetTickCount( );
	while( 1 )
	{
		if( prev_count == UINT_MAX )
		{
			prev_count = 0;
		}
		if( count <= prev_count )
		{
			prev_count++;
			count = prev_count;
		}
		else
		{
			prev_count = count;
		}

//	,       :
		string		name = TimeToString( TimeGMT( ), TIME_DATE | TIME_MINUTES | TIME_SECONDS ) + " " + DoubleToString( count, 0 );
		if( ObjectFind( 0, name ) < 0 )
		{
			return( name );
		}
	}

	return( NULL );
}
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//	   :
//---------------------------------------------------------------------
class TFieldDisplay : public CChartObjectEdit
{
protected:
	long		chart_id;
	int			sub_window;
	long		chart_width;																								//    
	long		chart_height;																								//    
	long		chart_width_step;																						//     
	long		chart_height_step;																					//     
	int			columns_number;																							//  
	int			limes_number;																								//  
	int			curr_column;
	int			curr_row;

private:
	int			type;																												//    ( ,  )

private:
	void		SetParams( long _chart_id, int _window, int _cols, int _lines );//   

public:
	string	GetUniqName( );																							//   
	bool		Create( long _chart_id, int _window, int _cols, int _lines, int _col, int _row );
	void		RecalcAndRedraw( );																					//    
	
public:
	void		TFieldDisplay( );																						// 
	void		~TFieldDisplay( );																					// 
};
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
void
TFieldDisplay::TFieldDisplay( )
{
}

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
void
TFieldDisplay::~TFieldDisplay( )
{
}

//---------------------------------------------------------------------
//	C :
//---------------------------------------------------------------------
bool
TFieldDisplay::Create( long _chart_id, int _window, int _cols, int _lines, int _col, int _row )
{
	this.curr_column = _col;
	this.curr_row = _row;
	SetParams( _chart_id, _window, _cols, _lines );

	return( this.Create( this.chart_id, this.GetUniqName( ), this.sub_window, ( int )( _col * this.chart_width_step ), ( int )( _row * this.chart_height_step )));
}

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
void
TFieldDisplay::SetParams( long _chart_id, int _window, int _cols, int _lines )
{
	this.chart_id = _chart_id;
	this.sub_window = _window;
	this.columns_number = _cols;
	this.limes_number = _lines;

//	    :
	this.chart_width = GetSystemMetrics( SM_CXFULLSCREEN );
	this.chart_height = GetSystemMetrics( SM_CYFULLSCREEN );

//	   :
	this.chart_width_step = this.chart_width / _cols;
	this.chart_height_step = this.chart_height / _lines;
}

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
void
TFieldDisplay::RecalcAndRedraw( )
{
//	    :
	long	width = GetSystemMetrics( SM_CXFULLSCREEN );
	long	height = GetSystemMetrics( SM_CYFULLSCREEN );
	if( width == this.chart_width && height == this.chart_height )
	{
		return;
	}

	this.chart_width = width;
	this.chart_height = height;

//	   :
	this.chart_width_step = this.chart_width / this.columns_number;
	this.chart_height_step = this.chart_height / this.limes_number;

//	    :
	this.X_Distance(( int )( this.curr_column * this.chart_width_step ));
	this.Y_Distance(( int )( this.curr_row * this.chart_height_step ));
}

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
string
TFieldDisplay::GetUniqName( )
{
	static uint	prev_count = 0;

	uint			count = GetTickCount( );
	while( 1 )
	{
		if( prev_count == UINT_MAX )
		{
			prev_count = 0;
		}
		if( count <= prev_count )
		{
			prev_count++;
			count = prev_count;
		}
		else
		{
			prev_count = count;
		}

//	,       :
		string		name = TimeToString( TimeGMT( ), TIME_DATE | TIME_MINUTES | TIME_SECONDS ) + " " + DoubleToString( count, 0 );
		if( ObjectFind( 0, name ) < 0 )
		{
			return( name );
		}
	}

	return( NULL );
}
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//	    :
//---------------------------------------------------------------------
class TableDisplay : public CList
{
protected:
	long		chart_id;
	int			sub_window;
	ENUM_BASE_CORNER	corner;

public:
	void		SetParams( long _chart_id, int _window, ENUM_BASE_CORNER _corner = CORNER_LEFT_UPPER );
	int			AddTitleObject( int _cols, int _lines, int _col, int _row, string _title, color _color, string _fontname = "Arial", int _fontsize = 10 );
	int			AddFieldObject( int _cols, int _lines, int _col, int _row, color _color, string _fontname = "Arial", int _fontsize = 10 );
	bool		SetColor( int _index, color _color );
	bool		SetFont( int _index, string _fontname, int _fontsize );
	bool		SetText( int _index, string _text );
	bool		SetAnchor( int _index, ENUM_ANCHOR_POINT _anchor );

public:
	void		TableDisplay( );
	void		~TableDisplay( );
};
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
void
TableDisplay::TableDisplay( )
{
	this.chart_id = 0;
	this.sub_window = 0;
	this.corner = CORNER_LEFT_UPPER;
}

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
void
TableDisplay::~TableDisplay( )
{
//	  :
	this.Clear( );
}

//---------------------------------------------------------------------
//	      :
//---------------------------------------------------------------------
void
TableDisplay::SetParams( long _chart_id, int _window, ENUM_BASE_CORNER _corner )
{
	this.chart_id = _chart_id;
	this.sub_window = _window;
	this.corner = _corner;
}

//---------------------------------------------------------------------
//	     ""   :
//---------------------------------------------------------------------
int
TableDisplay::AddTitleObject( int _cols, int _lines, int _col, int _row, string _title, color _color, string _fontname, int _fontsize )
{
	TTitleDisplay*		title = new TTitleDisplay( );
	title.Create( this.chart_id, this.sub_window, _cols, _lines, _col, _row );
	title.Description( _title );
	title.Color( _color );
	title.Font( _fontname );
	title.FontSize( _fontsize );
	title.Corner( this.corner );
	return( this.Add( title ));
}

//---------------------------------------------------------------------
//	     " "   :
//---------------------------------------------------------------------
int
TableDisplay::AddFieldObject( int _cols, int _lines, int _col, int _row, color _color, string _fontname, int _fontsize )
{
	TFieldDisplay*		field = new TFieldDisplay( );
	field.Create( this.chart_id, this.sub_window, _cols, _lines, _col, _row );
	field.Description( "" );
	field.Color( _color );
	field.Font( _fontname );
	field.FontSize( _fontsize );
	field.Corner( this.corner );
	return( this.Add( field ));
}

//---------------------------------------------------------------------
//	   :
//---------------------------------------------------------------------
bool
TableDisplay::SetAnchor( int _index, ENUM_ANCHOR_POINT _anchor )
{
	CChartObjectText*	object = GetNodeAtIndex( _index );
	if( object == NULL )
	{
		return( false );
	}
	return( object.Anchor( _anchor ));
}

//---------------------------------------------------------------------
//	    :
//---------------------------------------------------------------------
bool
TableDisplay::SetColor( int _index, color _color )
{
	CChartObjectText*	object = GetNodeAtIndex( _index );
	if( object == NULL )
	{
		return( false );
	}
	return( object.Color( _color ));
}
//---------------------------------------------------------------------
//	     :
//---------------------------------------------------------------------
bool
TableDisplay::SetFont( int _index, string _fontname, int _fontsize )
{
	CChartObjectText*	object = GetNodeAtIndex( _index );
	if( object == NULL )
	{
		return( false );
	}

	if( object.Font( _fontname ) == false )
	{
		return( false );
	}
	return( object.FontSize( _fontsize ));
}

//---------------------------------------------------------------------
//	     :
//---------------------------------------------------------------------
bool
TableDisplay::SetText( int _index, string _text )
{
	CChartObjectText*	object = GetNodeAtIndex( _index );
	if( object == NULL )
	{
		return( false );
	}
	return( object.Description( _text ));
}
//---------------------------------------------------------------------
